/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Matthias Jung
 */

#include "PrechargeChecker.h"
#include "../../TimingCalculation.h"


void PrechargeChecker::delayToSatisfyConstraints(ScheduledCommand &command)
const
{
    //return;
    sc_assert(command.getCommand() == Command::Precharge);

    ScheduledCommand lastCommand = state.getLastScheduledCommand(command.getBank());

    if (lastCommand.isValidCommand()) {
        // the first two cases happen when a resfresh interrups the command sequence of a transaction
        // (e.g. commands to process transaction are PRE-ACT-RD and refresh happens after the PRE or after the ACT)
        if (lastCommand.getCommand() == Command::Precharge
                || lastCommand.getCommand() == Command::PreB) {
            command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                  config.memSpec.tRP);
        } else if (lastCommand.getCommand() == Command::Activate
                   || lastCommand.getCommand() == Command::ActB) {
            command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                  config.memSpec.tRCD);
        }

        else if (lastCommand.getCommand() == Command::Read) {
            command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                  config.memSpec.tRTP);
        } else if (lastCommand.getCommand() == Command::Write) {
            command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                  config.memSpec.tWL + getWriteAccessTime() + config.memSpec.tWR);

        } else if (lastCommand.getCommand() == Command::PDNAX) {
            command.establishMinDistanceFromStart(lastCommand.getStart(),
                                                  config.memSpec.tXP);
        } else
            reportFatal("Precharge Checker",
                        "Precharge can not follow " + commandToString(lastCommand.getCommand()));
    }

    ScheduledCommand lastActivate = state.getLastCommand(Command::Activate,
                                                         command.getBank());
    if (lastActivate.isValidCommand()) {
        command.establishMinDistanceFromStart(lastActivate.getStart(),
                                              config.memSpec.tRAS);
    }

    state.bus.moveCommandToNextFreeSlot(command);
}

